src/oc-id/config/routes.rb
OcId::Application.routes.draw do
  root 'home#index'
  get 'id', to: 'home#index'

  scope :id do
    use_doorkeeper

    get 'signin', to: 'sessions#new'
    delete 'signout', to: 'sessions#destroy'

    post '/auth/chef/callback', to: 'sessions#create'
    get '/auth/failure', to: 'sessions#retry'

    resources :sessions, only: [:new, :create, :destroy]
    resource :password_reset, path: '/password-reset', except: [:destroy, :edit]

    resource :profile, only: [:show, :update] do
      put  "password" => "profiles#change_password"
      get  "email" => "profiles#change_email"
      post "regen_key"
    end

    resource :zendesk, only: [:show] do
      get 'signout', to: 'zendesks#signout'
    end

    namespace :v1 do
      resources :users, only: :show

      get 'me', to: 'users#me'
      get 'me/organizations', to: 'users#organizations'
      get 'status', to: 'health#show'
    end
  end
end

src/oc-id/app/controllers/profiles_controller.rb
class ProfilesController < ApplicationController
  #
  # GET /id/profile
  #
  # Shows the user their profile page.
  #
  def show
    redirect_to signin_path unless signed_in?
    @user = current_user
  end

  #
  # PUT /id/profile
  #
  # Updates the current user's profile with the provided information.
  #
  def update
    @user = current_user
    updated_email = false

    # Note that if an email address is provided, don't update it right away.
    # Instead send a confirmation email and let that email link update the
    # email address.
    if params[:user].key?(:email) && @user.email != params[:user][:email]
      EmailVerifyMailer.email_verify(@user, params[:user][:email]).deliver_now
      params[:user].delete(:email)
      updated_email = true
    end

    if @user.update_attributes(params[:user])
      message = I18n.t('profile.update_successful')
      message << "\n" + I18n.t('profile.email_change_sent') if updated_email
      redirect_to profile_path, :notice => message
    else
      render 'show'
    end
  end

  #
  # PUT /id/profile/password
  #
  # Changes the user's password.
  #
  def change_password
    @user = current_user
    @user.update_password(params)

    if @user.errors.empty?
      redirect_to profile_path, :notice => I18n.t('profile.password_changed')
    else
      flash.now[:alert] = I18n.t('errors.passwords.problem')
      render 'show', :status => :forbidden
    end
  end

  #
  # GET /id/profile/change_email
  #
  # Changes the user's email.
  #
  # This should really be a PUT but we are using GET to make it easier to access
  # the end-point from an email without having to dive into javascript.
  # The initiating action for this is a POST/PUT to /id/profile that contains
  # an email change. The handler for that sends an email with a link to this
  # end-point to confirm the change.
  #
  # Important caveats: this method may be called when the user is signed into a
  # different account or when the user is not signed in at all. If we are unable
  # to redirect to a profile page because the user isn't signed in, we simply go
  # to the signin page.
  #
  def change_email
    @user = User.find(URI.escape(params[:username])) if params[:username].present?
    return goto_forbidden('errors.emails.invalid_username', name: params[:username]) if @user.nil?
    return goto_forbidden('errors.emails.invalid_signature') unless valid_signature?

    @user.update_attributes('email' => params[:email])
    return goto_forbidden('errors.emails.problem') unless @user.errors.empty?

    target_path = signed_in? ? profile_path : signin_path
    redirect_to target_path, :notice => I18n.t('profile.email_changed', name: params[:username])
  end

  #
  # POST /id/profile/regen_key
  #
  # Resets the user's private key.
  #
  def regen_key
    @user = current_user
    @user.regen_private_key
    send_data @user.private_key, :type => "application/pem-keys", :disposition => "attachment", :filename => "#{@user.username}.pem"
  end

  private

  def goto_forbidden(message, *args)
    if signed_in?
      flash.now[:alert] = I18n.t(message, *args)
      render 'show', status: :forbidden
    else
      redirect_to signin_path, notice: I18n.t(message, *args)
    end
  end


  def valid_signature?
    return false unless [:signature, :email, :expires].all? { |p| params[p].present? }

    # Validate the signature against the user's current primary email address using
    # the new email address as a "payload" to verify that the email change request
    # link was not tampered with.
    Signature.new(
      @user.username,
      @user.email,
      params[:expires],
      Settings.secret_key_base,
      params[:email],
    ).valid_for?(params[:signature])
  end
end

src/oc-id/app/views/profiles/_change_password.html.erb
<div class="medium-12 columns">
  <h3>Change Your Password</h3>
  <%= form_tag(password_profile_path, {:method => 'put'}) do -%>
    <div class="row">
      <div class="column">
        <%= error_message_for(@user, :base) %>
      </div>
    </div>
    <div class="row">
      <div class="column">
        <label>Current Password</label>
        <%= password_field_tag :current_password, nil, :required => true, :class => 'radius' %>
        <%= error_message_for(@user, :current_password) %>
      </div>
    </div>
    <div class="row">
      <div class="column">
        <label>New Password</label>
        <%= password_field_tag :new_password, nil, :required => true, :class => 'radius' %>
        <%= error_message_for(@user, :new_password) %>
      </div>
    </div>
    <div class="row">
      <div class="column">
        <label>Confirm Password</label>
        <%= password_field_tag :password_confirmation, nil, :required => true, :class => 'radius' %>
        <%= error_message_for(@user, :password_confirmation) %>
      </div>
    </div>
    <div>
      <button type="submit" class="button">Change Password</button>
    </div>
  <% end -%>
</div>

src/oc-id/app/views/profiles/_generate_key.html.erb
<h3>Reset Your Private Key</h3>
<p>If you've lost your private key, or would like to replace it, click the button below to download one now.</p>
<p>
  When you do this,
  <strong>your old key will stop working.</strong>
  This key replaces your current key.
  We do not store a copy of this key, so please keep it somewhere safe.
</p>

<%= form_tag(regen_key_profile_path, :method => :post) do %>
  <%= submit_tag "Get a New Key", :class => "button" %>
<% end %>

src/oc-id/app/views/profiles/_profile.html.erb
<h3>Profile</h3>
<%= form_for(@user, :url => :profile, :method => :put, :html => {'data-abide' => ''}) do |f| %>
  <div class="row">
    <div class="medium-12 columns">
      <%= f.label :first_name %>
      <%= f.text_field :first_name, :required => true, :class => 'radius' %>
      <small class="error">Required</small>
    </div>
  </div>
  <div class="row">
    <div class="medium-12 columns">
      <%= f.label :middle_name %>
      <%= f.text_field :middle_name, :class => 'radius' %>
    </div>
  </div>
  <div class="row">
    <div class="medium-12 columns">
      <%= f.label :last_name %>
      <%= f.text_field :last_name, :required => true, :class => 'radius' %>
      <small class="error">Required</small>
    </div>
  </div>
  <div class="row">
    <div class="medium-12 columns">
      <%= f.label :email %>
      <%= f.text_field :email, :required => true, :class => 'radius' %>
      <small class="error">Required</small>
    </div>
  </div>
  <div class="row">
    <div class="medium-12 columns">
      <%= f.submit 'Save Changes', :class => 'button' %>
    </div>
  </div>
<% end %>

src/oc-id/app/views/profiles/show.html.erb
<div class="large-4 medium-6 columns">
  <%= render "profile" %>
</div>
<div class="large-4 medium-6 columns">
  <%= render "change_password" %>
</div>
<div class="large-4 columns">
  <div class="medium-12 columns">
    <%= render "generate_key" %>
  </div>
</div>